;;; -*-Scheme-*-

;;; The structure "problem-sets" must be loaded from a file whenever
;;; the set of available problem sets changes, or when the default
;;; problem set changes.  Files should appear with name and extension, but
;;; without device, directory, or version; these will be supplied
;;; automatically.
;;;
;;; The first number is used as the "default" problem set
;;;
;;; Example problem-sets variable:

;(define problem-sets
;  `(1 (1  (load&reference "ps1-c-curve.scm" "ps1-debug.scm"))
;      (2  (copy "ps2-ans.scm") (load&reference "ps2-primes.scm"))
;      (3  (copy "ps3-ans.scm")
;	  (load&reference "ps3-squares.scm" "ps3-tri.scm"))
;      (4  (copy "ps4-ans.scm") (load&reference "ps4-doctor.scm")
;	  (select "ps4-ans.scm"))
;      (5  (copy "ps5-ans.scm")
;	  (load&reference "ps5-graph.scm" "ps5-imp.scm" "ps5-res.scm"))
;      (6  (copy "ps6-mods.scm") (load&reference "ps6-adv.scm"))
;      (7  (copy "ps7-ans.scm")
;	  (load&reference "ps7-ps.scm" "ps7-psutil.scm" "ps7-ratnum.scm"))
;      (8  (copy "ps8-mods.scm") (load&reference "ps8-mceval.scm"))))

(define problem-sets
  `(9  (1  (load "ps1go.scm") (copy "ps1-sin.scm"))
       (2  (message "There is no code loaded for problem set 2"))
       (3  (load "ps3go.scm") (copy "ps3-utls.scm" "ps3-sqr.scm" "ps3-tri.scm"))
       (4  (load "ps4go.scm") (copy "ps4gram.scm"))
       (5  (load "ps5go.scm") (copy "ps5-code.scm" "E263.scm" "put-get.scm" "types.scm"))
       (q1 (load "tdata.scm" "costs.scm") (copy "costs.scm" "tdata.scm"))
       (6  (load "ps6go.scm") (copy "silverado.scm"))
       (7  (load&reference "ps7code.scm") (copy "ps7code2.scm"))
       (8  (load&reference "search.scm") (copy "search.scm" "puzz.scm" "lang.scm"))
       (q2 (load "sobj.scm") (copy "sobj.scm"))
       (9  (load "ps9-load.scm") (copy "ps9-mods.scm"))
       (final (load "mceval.scm") (copy "mceval.scm" "macro.scm"))
       ))




